#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
	FILE *file;
	long fsize;
	char *code;
	int ip = 0;
	int p;
	char mem[0x400];
	int stack[0x40];
	int sp = 0x40;
	int nest;

	if(argc != 2) {
		fprintf(stderr,"Use: bf file.bf\n");
		return 1;
	}
	if((file = fopen(argv[1],"r")) == NULL) {
		fprintf(stderr,"Can not open file\n");
		return 1;
	}
	fseek(file,0,SEEK_END);
	fsize = ftell(file);
	rewind(file);

	code = malloc(fsize+1);
	if(code == NULL) {
		fprintf(stderr,"Out of memory\n");
		return 1;
	}

	fread(code,fsize,1,file);
	code[fsize] = 0;
	fclose(file);

	for(p=0;p<0x400;p++) {
		mem[p] = 0;
	}
	p = 0;

	while(code[ip] != 0) {
		switch(code[ip]) {
		case '+':
			mem[p]++; break;
		case '-':
			mem[p]--; break;
		case '>':
			p++; p = p & 0x3ff; break;
		case '<':
			p--; p = p & 0x3ff; break;
		case '.':
			putchar(mem[p]); break;
		case ',':
			mem[p] = getchar(); break;
		case '[':
			stack[--sp] = ip;
			nest = 1;
			while(nest != 0) {
				ip++;
				if(code[ip] == '[') nest++;
				if(code[ip] == ']') nest--;
				if(code[ip] == 0) {
					fprintf(stderr,"Unmatched [\n");
					return 1;
				}
			}
			ip--;
			break;
		case ']':
			if(mem[p] != 0) {
				ip = stack[sp];
				break;
			}
			sp++;
			break;
		};
		ip++;
	}

	printf("\n[End of program]\n");
	free(code);
	return 0;
}

